ompi/mca/coll/sm/coll_sm.h File Reference.TH "ompi/mca/coll/sm/coll_sm.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/coll/sm/coll_sm.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mpi.h'\fP
.br
\fC#include 'opal/mca/mca.h'\fP
.br
\fC#include 'orte/mca/ns/ns_types.h'\fP
.br
\fC#include 'ompi/mca/coll/coll.h'\fP
.br
\fC#include 'ompi/mca/mpool/mpool.h'\fP
.br
\fC#include 'ompi/mca/common/sm/common_sm_mmap.h'\fP
.br

.SS "Data Structures"

.in +1c
.ti -1c
.RI "struct \fBmca_coll_base_comm_t\fP"
.br
.RI "\fIStructure for the sm coll module to hang off the communicator. \fP"
.in -1c
.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBD\fP(foo)"
.br
.ti -1c
.RI "#define \fBSPIN\fP   continue"
.br
.ti -1c
.RI "#define \fBFLAG_SETUP\fP(flag_num, flag, data)"
.br
.RI "\fIMacro to setup flag usage. \fP"
.ti -1c
.RI "#define \fBFLAG_WAIT_FOR_IDLE\fP(flag)   while (0 != (flag)->mcsiuf_num_procs_using) SPIN"
.br
.RI "\fIMacro to wait for the in-use flag to become idle (used by the root). \fP"
.ti -1c
.RI "#define \fBFLAG_WAIT_FOR_OP\fP(flag, op)   while ((op) != flag->mcsiuf_operation_count) SPIN"
.br
.RI "\fIMacro to wait for a flag to indicate that it's ready for this operation (used by non-root processes to know when FLAG_SET() has been called). \fP"
.ti -1c
.RI "#define \fBFLAG_RETAIN\fP(flag, num_procs, op_count)"
.br
.RI "\fIMacro to set an in-use flag with relevant data to claim it. \fP"
.ti -1c
.RI "#define \fBFLAG_RELEASE\fP(flag)   opal_atomic_add(&(flag)->mcsiuf_num_procs_using, -1)"
.br
.RI "\fIMacro to release an in-use flag from this process. \fP"
.ti -1c
.RI "#define \fBCOPY_FRAGMENT_IN\fP(convertor, index, rank, iov, max_data)"
.br
.RI "\fIMacro to copy a single segment in from a user buffer to a shared segment. \fP"
.ti -1c
.RI "#define \fBCOPY_FRAGMENT_OUT\fP(convertor, src_rank, index, iov, max_data)"
.br
.RI "\fIMacro to copy a single segment out from a shared segment to a user buffer. \fP"
.ti -1c
.RI "#define \fBCOPY_FRAGMENT_BETWEEN\fP(src_rank, dest_rank, index, len)"
.br
.RI "\fIMacro to memcpy a fragment between one shared segment and another. \fP"
.ti -1c
.RI "#define \fBPARENT_NOTIFY_CHILDREN\fP(children, num_children, index, value)"
.br
.RI "\fIMacro to tell children that a segment is ready (normalize the child's ID based on the shift used to calculate the 'me' node in the tree). \fP"
.ti -1c
.RI "#define \fBCHILD_WAIT_FOR_NOTIFY\fP(rank, index, value)"
.br
.RI "\fIMacro for childen to wait for parent notification (use real rank). \fP"
.ti -1c
.RI "#define \fBCHILD_NOTIFY_PARENT\fP(child_rank, parent_rank, index, value)"
.br
.RI "\fIMacro for children to tell parent that the data is ready in their segment. \fP"
.ti -1c
.RI "#define \fBPARENT_WAIT_FOR_NOTIFY_SPECIFIC\fP(child_rank, parent_rank, index, value)"
.br
.RI "\fIMacro for parent to wait for a specific child to tell it that the data is in the child's segment. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_coll_sm_bootstrap_comm_setup_t\fP \fBmca_coll_sm_bootstrap_comm_setup_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_sm_bootstrap_comm_key_t\fP \fBmca_coll_sm_bootstrap_comm_key_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_sm_bootstrap_header_extension_t\fP \fBmca_coll_sm_bootstrap_header_extension_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_sm_component_t\fP \fBmca_coll_sm_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_sm_tree_node_t\fP \fBmca_coll_sm_tree_node_t\fP"
.br
.RI "\fIConvenienve typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_sm_in_use_flag_t\fP \fBmca_coll_sm_in_use_flag_t\fP"
.br
.RI "\fIConvenienve typedef. \fP"
.ti -1c
.RI "typedef \fBmca_coll_base_mpool_index_t\fP \fBmca_coll_base_mpool_index_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_coll_base_comm_t\fP \fBmca_coll_base_comm_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_coll_sm_init_query\fP (bool enable_progress_threads, bool enable_mpi_threads)"
.br
.ti -1c
.RI "const struct mca_coll_base_module_1_0_0_t * \fBmca_coll_sm_comm_query\fP (struct ompi_communicator_t *comm, int *priority, struct \fBmca_coll_base_comm_t\fP **data)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_comm_unquery\fP (struct ompi_communicator_t *comm, struct \fBmca_coll_base_comm_t\fP *data)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_bootstrap_finalize\fP (void)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_allgather_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int rcount, struct ompi_datatype_t *rdtype, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_allgatherv_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int *rcounts, int *disps, struct ompi_datatype_t *rdtype, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_allreduce_intra\fP (void *sbuf, void *rbuf, int count, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory allreduce. \fP"
.ti -1c
.RI "int \fBmca_coll_sm_alltoall_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int rcount, struct ompi_datatype_t *rdtype, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_alltoallv_intra\fP (void *sbuf, int *scounts, int *sdisps, struct ompi_datatype_t *sdtype, void *rbuf, int *rcounts, int *rdisps, struct ompi_datatype_t *rdtype, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_alltoallw_intra\fP (void *sbuf, int *scounts, int *sdisps, struct ompi_datatype_t **sdtypes, void *rbuf, int *rcounts, int *rdisps, struct ompi_datatype_t **rdtypes, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_barrier_intra\fP (struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory barrier. \fP"
.ti -1c
.RI "int \fBmca_coll_sm_bcast_intra\fP (void *buff, int count, struct ompi_datatype_t *datatype, int root, struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory broadcast. \fP"
.ti -1c
.RI "int \fBmca_coll_sm_bcast_log_intra\fP (void *buff, int count, struct ompi_datatype_t *datatype, int root, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_exscan_intra\fP (void *sbuf, void *rbuf, int count, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_gather_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int rcount, struct ompi_datatype_t *rdtype, int root, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_gatherv_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int *rcounts, int *disps, struct ompi_datatype_t *rdtype, int root, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_reduce_intra\fP (void *sbuf, void *rbuf, int count, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, int root, struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory reduction. \fP"
.ti -1c
.RI "int \fBmca_coll_sm_reduce_log_intra\fP (void *sbuf, void *rbuf, int count, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, int root, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_reduce_scatter_intra\fP (void *sbuf, void *rbuf, int *rcounts, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_scan_intra\fP (void *sbuf, void *rbuf, int count, struct ompi_datatype_t *dtype, struct \fBompi_op_t\fP *op, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_scatter_intra\fP (void *sbuf, int scount, struct ompi_datatype_t *sdtype, void *rbuf, int rcount, struct ompi_datatype_t *rdtype, int root, struct ompi_communicator_t *comm)"
.br
.ti -1c
.RI "int \fBmca_coll_sm_scatterv_intra\fP (void *sbuf, int *scounts, int *disps, struct ompi_datatype_t *sdtype, void *rbuf, int rcount, struct ompi_datatype_t *rdtype, int root, struct ompi_communicator_t *comm)"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBmca_coll_sm_component_t\fP \fBmca_coll_sm_component\fP"
.br
.RI "\fIGlobal component instance. \fP"
.ti -1c
.RI "uint32_t \fBmca_coll_sm_iov_size\fP"
.br
.RI "\fIGlobal variables used in the macros (essentially constants, so these are thread safe). \fP"
.ti -1c
.RI "int32_t \fBmca_coll_sm_bogus_free_after\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define CHILD_NOTIFY_PARENT(child_rank, parent_rank, index, value)"
.PP
\fBValue:\fP
.PP
.nf
((size_t volatile *) \
     (((char*) (index)->mcbmi_control) + \
      (mca_coll_sm_component.sm_control_size * \
       (parent_rank))))[(child_rank)] = (value)
.fi
Macro for children to tell parent that the data is ready in their segment. 
.PP
Used for fan in operations. 
.SS "#define CHILD_WAIT_FOR_NOTIFY(rank, index, value)"
.PP
\fBValue:\fP
.PP
.nf
do { \
        uint32_t volatile *ptr = ((uint32_t*) \
                                  (((char*) index->mcbmi_control) + \
                                   ((rank) * mca_coll_sm_component.sm_control_size))); \
        while (0 == *ptr) SPIN; \
        (value) = *ptr; \
        *ptr = 0; \
    } while (0)
.fi
Macro for childen to wait for parent notification (use real rank). 
.PP
Save the value passed and then reset it when done. Used in fan out operations. 
.SS "#define COPY_FRAGMENT_BETWEEN(src_rank, dest_rank, index, len)"
.PP
\fBValue:\fP
.PP
.nf
memcpy(((index)->mcbmi_data + \
            ((dest_rank) * mca_coll_sm_component.sm_fragment_size)), \
           ((index)->mcbmi_data + \
            ((src_rank) * \
             mca_coll_sm_component.sm_fragment_size)), \
           (len))
.fi
Macro to memcpy a fragment between one shared segment and another. 
.PP
.SS "#define COPY_FRAGMENT_IN(convertor, index, rank, iov, max_data)"
.PP
\fBValue:\fP
.PP
.nf
(iov).iov_base = \
        (index)->mcbmi_data + \
        ((rank) * mca_coll_sm_component.sm_fragment_size); \
    (max_data) = (iov).iov_len = mca_coll_sm_component.sm_fragment_size; \
    ompi_convertor_pack(&(convertor), &(iov), &mca_coll_sm_iov_size, \
                        &(max_data), &mca_coll_sm_bogus_free_after)
.fi
Macro to copy a single segment in from a user buffer to a shared segment. 
.PP
.SS "#define COPY_FRAGMENT_OUT(convertor, src_rank, index, iov, max_data)"
.PP
\fBValue:\fP
.PP
.nf
(iov).iov_base = (((char*) (index)->mcbmi_data) + \
                      ((src_rank) * mca_coll_sm_component.sm_fragment_size)); \
    ompi_convertor_unpack(&(convertor), &(iov), &mca_coll_sm_iov_size, \
                          &(max_data), &mca_coll_sm_bogus_free_after)
.fi
Macro to copy a single segment out from a shared segment to a user buffer. 
.PP
.SS "#define FLAG_RETAIN(flag, num_procs, op_count)"
.PP
\fBValue:\fP
.PP
.nf
(flag)->mcsiuf_num_procs_using = (num_procs); \
    (flag)->mcsiuf_operation_count = (op_count)
.fi
Macro to set an in-use flag with relevant data to claim it. 
.PP
.SS "#define FLAG_SETUP(flag_num, flag, data)"
.PP
\fBValue:\fP
.PP
.nf
(flag) = (mca_coll_sm_in_use_flag_t*) \
        (((char *) (data)->mcb_in_use_flags) + \
        ((flag_num) * mca_coll_sm_component.sm_control_size))
.fi
Macro to setup flag usage. 
.PP
.SS "#define PARENT_NOTIFY_CHILDREN(children, num_children, index, value)"
.PP
\fBValue:\fP
.PP
.nf
do { \
        for (i = 0; i < (num_children); ++i) { \
            *((size_t*) \
              (((char*) index->mcbmi_control) + \
               (mca_coll_sm_component.sm_control_size * \
                (((children)[i]->mcstn_id + root) % size)))) = (value); \
        } \
    } while (0)
.fi
Macro to tell children that a segment is ready (normalize the child's ID based on the shift used to calculate the 'me' node in the tree). 
.PP
Used in fan out opertations. 
.SS "#define PARENT_WAIT_FOR_NOTIFY_SPECIFIC(child_rank, parent_rank, index, value)"
.PP
\fBValue:\fP
.PP
.nf
do { \
        size_t volatile *ptr = ((size_t volatile *) \
                                (((char*) index->mcbmi_control) + \
                                 (mca_coll_sm_component.sm_control_size * \
                                  (parent_rank)))) + child_rank; \
        while (0 == *ptr) SPIN; \
        (value) = *ptr; \
        *ptr = 0; \
    } while (0)
.fi
Macro for parent to wait for a specific child to tell it that the data is in the child's segment. 
.PP
Save the value when done. Used for fan in operations. 
.SH "Function Documentation"
.PP 
.SS "int mca_coll_sm_allreduce_intra (void * sbuf, void * rbuf, int count, struct ompi_datatype_t * dtype, struct \fBompi_op_t\fP * op, struct ompi_communicator_t * comm)"
.PP
Shared memory allreduce. 
.PP
For the moment, all we're doing is a reduce to root==0 and then a broadcast. It is possible that we'll do something better someday. 
.SS "int mca_coll_sm_barrier_intra (struct ompi_communicator_t * comm)"
.PP
Shared memory barrier. 
.PP
Tree-based algorithm for a barrier: a fan in to rank 0 followed by a fan out using the barrier segments in the shared memory area.
.PP
There are 2 sets of barrier buffers -- since there can only be, at most, 2 outstanding barriers at any time, there is no need for more than this. The generalized in-use flags, control, and data segments are not used.
.PP
The general algorithm is for a given process to wait for its N children to fan in by monitoring a uint32_t in its barrier 'in' buffer. When this value reaches N (i.e., each of the children have atomically incremented the value), then the process atomically increases the uint32_t in its parent's 'in' buffer. Then the process waits for the parent to set a '1' in the process' 'out' buffer. Once this happens, the process writes a '1' in each of its children's 'out' buffers, and returns.
.PP
There's corner cases, of course, such as the root that has no parent, and the leaves that have no children. But that's the general idea. 
.SS "int mca_coll_sm_bcast_intra (void * buff, int count, struct ompi_datatype_t * datatype, int root, struct ompi_communicator_t * comm)"
.PP
Shared memory broadcast. 
.PP
For the root, the general algorithm is to wait for a set of segments to become available. Once it is, the root claims the set by writing the current operation number and the number of processes using the set to the flag. The root then loops over the set of segments; for each segment, it copies a fragment of the user's buffer into the shared data segment and then writes the data size into its childrens' control buffers. The process is repeated until all fragments have been written.
.PP
For non-roots, for each set of buffers, they wait until the current operation number appears in the in-use flag (i.e., written by the root). Then for each segment, they wait for a nonzero to appear into their control buffers. If they have children, they copy the data from their parent's shared data segment into their shared data segment, and write the data size into each of their childrens' control buffers. They then copy the data from their shared [local] data segment into the user's output buffer. The process is repeated until all fragments have been received. If they do not have children, they copy the data directly from the parent's shared data segment into the user's output buffer. 
.SS "int mca_coll_sm_reduce_intra (void * sbuf, void * rbuf, int count, struct ompi_datatype_t * dtype, struct \fBompi_op_t\fP * op, int root, struct ompi_communicator_t * comm)"
.PP
Shared memory reduction. 
.PP
Simply farms out to the associative or non-associative functions. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
